Index: FL/Fl.H
===================================================================
diff --git a/branches/branch-1.4/FL/Fl.H b/branches/branch-1.4/FL/Fl.H
--- a/branches/branch-1.4/FL/Fl.H	(Revision 12122)
+++ b/branches/branch-1.4/FL/Fl.H	(Arbeitskopie)
@@ -134,6 +134,7 @@
 private:
 
   static int use_high_res_GL_;
+  static int show_next_window_iconic_;
 
 public:
 
@@ -1266,6 +1267,15 @@
    */
   static int use_high_res_GL() { return use_high_res_GL_; }
 
+  /**  sets whether the next shown window should be openened
+   in iconic state.
+   */
+  static void show_next_window_iconic(int val) { show_next_window_iconic_ = val; }
+  /**  returns whether the next shown window should be openened
+   in iconic state.
+   */
+  static int show_next_window_iconic() { return show_next_window_iconic_; }
+
 #ifdef FLTK_HAVE_CAIRO
   /** \defgroup group_cairo Cairo Support Functions and Classes
       @{ 
Index: FL/Fl_Window.H
===================================================================
diff --git a/branches/branch-1.4/FL/Fl_Window.H b/branches/branch-1.4/FL/Fl_Window.H
--- a/branches/branch-1.4/FL/Fl_Window.H	(Revision 12122)
+++ b/branches/branch-1.4/FL/Fl_Window.H	(Arbeitskopie)
@@ -22,7 +22,6 @@
 #ifndef Fl_Window_H
 #define Fl_Window_H
 
-#include <FL/Fl.H>
 #include <FL/Fl_Group.H>
 #include <FL/Fl_Bitmap.H>
 #include <stdlib.h>
@@ -66,7 +65,6 @@
   int fullscreen_screen_left;
   int fullscreen_screen_right;
 
-  friend int Fl::arg(int argc, char **argv, int &i);
   friend class Fl_X;
   friend class Fl_Window_Driver;
   friend class Fl_PicoAndroid_Window_Driver;
Index: src/Fl.cxx
===================================================================
diff --git a/branches/branch-1.4/src/Fl.cxx b/branches/branch-1.4/src/Fl.cxx
--- a/branches/branch-1.4/src/Fl.cxx	(Revision 12122)
+++ b/branches/branch-1.4/src/Fl.cxx	(Arbeitskopie)
@@ -1883,6 +1883,7 @@
 }
 
 int Fl::use_high_res_GL_ = 0;
+int Fl::show_next_window_iconic_ = 0;
 
 int Fl::dnd()
 {
Index: src/Fl_Gl_Window.cxx
===================================================================
diff --git a/branches/branch-1.4/src/Fl_Gl_Window.cxx b/branches/branch-1.4/src/Fl_Gl_Window.cxx
--- a/branches/branch-1.4/src/Fl_Gl_Window.cxx	(Revision 12122)
+++ b/branches/branch-1.4/src/Fl_Gl_Window.cxx	(Arbeitskopie)
@@ -21,6 +21,7 @@
 
 extern int fl_gl_load_plugin;
 
+#include <FL/Fl.H>
 #include <FL/gl.h>
 #include <FL/Fl_Gl_Window.H>
 #include <FL/Fl_Gl_Window_Driver.H>
Index: src/Fl_arg.cxx
===================================================================
diff --git a/branches/branch-1.4/src/Fl_arg.cxx b/branches/branch-1.4/src/Fl_arg.cxx
--- a/branches/branch-1.4/src/Fl_arg.cxx	(Revision 12122)
+++ b/branches/branch-1.4/src/Fl_arg.cxx	(Arbeitskopie)
@@ -130,7 +130,7 @@
   s++; // point after the dash
 
   if (fl_match(s, "iconic")) {
-    Fl_Window::show_iconic_ = 1;
+    Fl::show_next_window_iconic(1);
     i++;
     return 1;
   } else if (fl_match(s, "kbd")) {
Index: src/Fl_x.cxx
===================================================================
diff --git a/branches/branch-1.4/src/Fl_x.cxx b/branches/branch-1.4/src/Fl_x.cxx
--- a/branches/branch-1.4/src/Fl_x.cxx	(Revision 12122)
+++ b/branches/branch-1.4/src/Fl_x.cxx	(Arbeitskopie)
@@ -2452,10 +2452,11 @@
     XWMHints *hints = XAllocWMHints();
     hints->input = True;
     hints->flags = InputHint;
-    if (Fl_Window::show_iconic_) {
+    if (Fl_Window::show_iconic_ || Fl::show_next_window_iconic()) {
       hints->flags |= StateHint;
       hints->initial_state = IconicState;
       Fl_Window::show_iconic_ = 0;
+      Fl::show_next_window_iconic(0);
       showit = 0;
     }
     if (Fl_X11_Window_Driver::driver(win)->icon_->legacy_icon) {
